package gest_bacino;

import java.net.*;
import java.io.*;
import java.lang.*;
public class Manager {
	static String filemonitoring, fileanomalie;
	static String altro_manager;
	static int bufferLength = 256;
	static int tempo_ril = 25000;
	/* intervallo tra una rilevazione e l'altra */
	static int wt = 1000;
	/*waiting time: tempo che si intende xdere nell'attesa di una
	risposta da un eventuale manager secondario (PrimoContatto)
	oppure che un secondario attende dopo un AreYouAlive? (CoordTime)*/
	static int aya_time = 10000;
	/* AreYouAliveTime: tempo tra un AYA message e l'altro */
	static int mt = 5000; /* misuration time: tempo che si concede ai sensori x inviare la loro misura */
	static boolean attendo_sec = true;
	static boolean chiusura_sec = false;
	static boolean chiusura_prim = false;
	static int max_tot_sens = 10;	
	static InetAddress indirizIP[] = new InetAddress[max_tot_sens];
	static int portasens[] = new int[max_tot_sens];
	static String nome_sens[] = new String[max_tot_sens];
	static String grandezza[] = new String[max_tot_sens];
	static String unita_mis[] = new String[max_tot_sens];
	/* array delle caratteristiche dei sensori collegati */
public static boolean controllo(String ip) {
	try {
		byte prova[];
		prova = (InetAddress.getByName(ip)).getAddress();
	} catch (UnknownHostException e) {
		System.out.println("Host non conosciuto!");
		System.exit(1);
	}
	return true;
}
/**
 * creazione di un file. Avrei conflitto
 * se avessi un solo file system e nominassi
 * ugualmente due file di un primario e di un
 * secondario, oppure rischierei comunque
 * di perdere dati raccolti in precedenza.
 */

public static void creafile(String nome, String cont) throws IOException {
	File ff = new File(nome);
	if (ff.exists()) {
		System.out.println("\nATTENZIONE:\nil file <" + nome + "> esiste gi.");
		System.out.println("Rinominare il file esistente.\nESCO");
		System.exit(1);
	}
	OutputStream fg = new FileOutputStream(ff);
	fg.write(cont.getBytes());
	fg.close();
}
public static void main(String[] args) throws Exception {
	String uso = "Uso: manager [IP address dell' altro manager] [file dati] [file anomalie]\nCHIUDO";


	/* CONTROLLO ARGOMENTI */
	if ((args.length != 4) || !(controllo(args[1]))) {
		System.out.println(uso);
		System.exit(1);
	}
	altro_manager = args[1];
	/* creazione (o apertura) del file
	rilevazioni eseguite args[2] (per es. data.txt) */

	/*problema: devo distinguere tra primario e secondario altrimenti c'
	conflitto tra i file se si lavora sulla stessa macchina. Allora aggiungo 
	i nomi di tali file agli argomenti della chiamata manager, in modo da 
	delegare ogni responsabilit al chiamante */

	creafile(args[2], "INIZIO");
	creafile(args[3], "INIZIO");
	filemonitoring = args[2];
	fileanomalie = args[3];
	/*  contatto l'altro manager: 
	se ottengo la risposta 				"Eccomi: comando IO" 
	allora sono il manager SECONDARIO;
	se ottengo la risposta 				"Eccomi: comando IO. ESCI" 
	allora sono di troppo ed esco; 
	altrimenti mi investo del ruolo di manager PRIMARIO */
	System.out.println("Ricerca Manager Primario: ");
	boolean pri_mario = (new PrimoContatto(args[1])).primario();
	if (pri_mario) {
		System.out.println("\nFar il manager PRIMARIO!");
		new CoordinamPrim();
		/* Thread che chiacchiera col secondario */
		new GestSensori();
		/*  Thread che chiacchiera coi sensori    */
		new GestoreTime(tempo_ril);
		/* Thread che manda impulsi temporali */
		new Input();
		/* Thread che accetta comandi dallo std in */
	} else {
		System.out.println("\nFar il manager SECONDARIO!");
		/* Thread che governa il secondario    */
		new GestSecond();
		/* Thread che manda msg are_you_alive */
		new CoordTime(10000);
	}
}
}
