package gest_bacino;

/**
 * features.txt  cos costruito:
 * [IP manager1] 
 * [porta_manager1]
 * [IP manager2]
 * [porta_manager2]
 * [nome sensore]
 * [grandezza misurata]
 * [unit di misura]
 * FINEFILE 
 */
import java.net.*;
import java.io.*;
import java.lang.*;
public class Sensore {
	static int cat = 10000; /* control alert time: tempo tra una misuraz e l'altra per proprio controllo */
	static boolean nonCeilSec;
	static String primAddr;
	static String secAddr;
	static int prPort, sePort;
	static int max_features = 20;
	static String ftrs[];
	static int wpt = 1000;	
	/* wait presentation time: tempo che si  disposti ad attendere la 
	risposta di un manager alla presentazione del sensore */
	static boolean chiusura_sens = false;

/**
 * Legge le caratteristiche del sensore nel FILE file
 */
public static String[] getFeatures(String file) throws java.lang.Exception {
	int indice = 0;
	String buff[];
	buff = new String[max_features];
	String stringa;
	BufferedReader inStream = new BufferedReader(new FileReader(file));
	while (!(stringa = inStream.readLine().trim()).equals("FINEFILE")) {
		buff[indice] = stringa;
		indice++;
	}
	return buff;
}
/**
 * l'argomento  il file "features.txt"  !!!
 * con le caratteristiche del sensore    !!!
 */
public static void main(String[] args) throws java.lang.Exception {
	byte status;
	Integer prt;
	ftrs = new String[max_features];
	/* buffer delle caratteristiche del sensore */
	ftrs = getFeatures(args[1]);
	status = (new SensPresent(0).statoManager());
	status = (byte) (status + 8 * (new SensPresent(2).statoManager()));
	prt("STATUS=" + status);
	prt = new Integer(ftrs[1]);
	prPort = prt.intValue();
	prt = new Integer(ftrs[3]);
	sePort = prt.intValue();
	verifica(status);
	
	new SensWait();
	new SensAlert();
}
/**
 * STAMPA
 */
public static void prt(String scritta) {
	System.out.println(scritta);
}
/**
 * VERIFICA che la variabile  stato sia tornata con un valore 
 * lecito e la legge: stabilisce chi sia il primario e se sia
 * connesso un secondario.
 */
public static void verifica(byte stato) {
	int x;
	switch (stato) {
		case 0x24 :
			{
				prt("Nessuna Risposta.\nESCO");
				System.exit(1);
			}
			break;
		case 0x12 :
			{
				prt("ANOMALIA: due manager secondari.\nESCO");
				System.exit(1);
			}
			break;
		case 0x22 :
		case 0x14 :
			{
				prt("ANOMALIA: risponde solo il manager secondario.\nESCO");
				System.exit(1);
			}
			break;
		case 0x09 :
			{
				prt("ANOMALIA: due manager primari.\nESCO");
				System.exit(1);
			}
			break;
		case 0x11 :
			{
				primAddr = ftrs[0];
				secAddr = ftrs[2];
				nonCeilSec = false;
			}
			break;
		case 0x0A :
			{
				x = prPort;
				prPort = sePort;
				sePort = x;
				primAddr = ftrs[2];
				secAddr = ftrs[0];
				nonCeilSec = false;
			}
			break;
		case 0x21 :
			{
				primAddr = ftrs[0];
				secAddr = ftrs[2];
				nonCeilSec = true;
			}
			break;
		case 0x0C :
			{
				x = prPort;
				prPort = sePort;
				sePort = x;
				primAddr = ftrs[2];
				secAddr = ftrs[0];
				nonCeilSec = true;
			}
			break;
		default :
			{
				prt("STATUS=" + stato + "  un caso non previsto!\nESCO");
				System.exit(1);
			}
	}
}
}
