package gest_bacino;

import java.net.*;
import java.io.*;
public class Synchro {
/* registra il nome, la grandezza misurata e la relativa unit
di misura di un sensore appena entrato nel secondario */
public synchronized void aggiorn(int g, String[] arr) {
	Manager.nome_sens[g] = arr[0];
	Manager.grandezza[g] = arr[2];
	Manager.unita_mis[g] = arr[3];
}
/* registra l'indirizzo IP e la porta di un sensore */
public synchronized void aggIP(int param, String[] arr) {
	try {
		Manager.indirizIP[param] = InetAddress.getByName(arr[2]);
	} catch (IOException h) {
		System.out.println("problemi aggIP");
	}
	Manager.portasens[param] = (new Integer(arr[3])).intValue();
	Manager.nome_sens[param] = arr[0];
}
/* registra l'indirizzo IP e la porta di un sensore */
public synchronized void aggIP(int param, String no, InetAddress in, int po) {
	Manager.indirizIP[param] = in;
	Manager.portasens[param] = po;
	Manager.nome_sens[param] = no;
}
/* restituisce il numero dei sensori collegati */
public synchronized int conta() {
	int x=0;
	for (int j=0; j< Manager.max_tot_sens; j++) if (Manager.nome_sens[j] != null) x++;
	return x;
}
/* annulla tutte le registrazioni effettuate per un sensore */
public synchronized void esce(int sx) {
	Manager.nome_sens[sx] = null;
	Manager.indirizIP[sx] = null;
	Manager.grandezza[sx] = null;
	Manager.unita_mis[sx] = null;
	Manager.portasens[sx] = 0;
	}
/* restituisce la prima posizione libera nell'array, basandosi su nome_sens[] */
public synchronized int libero() {
	boolean nontrovato = true;
	int x = -1;
	while (nontrovato && x < Manager.max_tot_sens) {
		x++;
		if (Manager.nome_sens[x] == null)
			nontrovato = false;
	}
	if (nontrovato) x=-1;
	return x;
}
/* restituisce una lista dei sensori registrati dal manager */
public synchronized void lista() {
	System.out.println("Lista dei sensori registrati:");
	for (int i = 0; i < Manager.max_tot_sens; i++)
		if (Manager.nome_sens[i] != null) {
			System.out.println(i + " " + Manager.nome_sens[i] + " " + Manager.grandezza[i]);
		}
}
/* controlla se nessun altro sensore registrato ha un nome uguale
a quello dato come parametro */
public synchronized boolean nome_unico(String nome) {
	boolean ok = true;
	for (int i=0; i<Manager.max_tot_sens; i++) if (Manager.nome_sens[i] != null)
	if(Manager.nome_sens[i].equals(nome)) ok = false;
	return ok;
}
/* Registra e notifica l'ingresso del sensore: come aggiorn() solo che si usa nel primario*/
public synchronized void notif_reg(String[] ingr, int posiz) {
	Manager.nome_sens[posiz] = ingr[0];
	Manager.grandezza[posiz] = ingr[2];
	Manager.unita_mis[posiz] = ingr[3];
	System.out.println("\n\nE' entrato il sensore " + posiz);
	System.out.println("         Ha nome:    " + Manager.nome_sens[posiz]);
	System.out.println("Misura la grandezza: " + Manager.grandezza[posiz]);
	System.out.println("Unit di misura:     " + Manager.unita_mis[posiz]);
}
/* Trova la posizione del sensore col nome param nell'array, se non trova nulla torna -1 */
public synchronized int posizione(String param) {
	int g = -1;
	for (int j = 0; j < Manager.max_tot_sens; j++) {
		if (Manager.nome_sens[j] != null) if (Manager.nome_sens[j].equals(param))
			g = j;
	}
	return g;
}
}
